// lastsim.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "lastsim.h"
#include <stdio.h>
#include <math.h>

#define WIDTH 300
#define HEIGHT 300
#define CHANGE 5                                 // 3000,3500
#define DISTANCE 999999
#define COUNTERFARBE 44                                   // 2200
#define STEPTHROUGH abstandzuObjekt/2400
#define KONSTANTE 0.1
#define FAKTORV 0.0000000000001
#define ZAEHLER 999
#define C 30000

#define MAX_LOADSTRING 100


struct ELEKTR
{
	float x,y,z,mass,current,vx,vy,vz,r,g,b;
};

struct FARBE
{
        float r,g,b;
};
struct PIXELSET
{
	float r,g,b;
	float farbr[COUNTERFARBE],farbg[COUNTERFARBE],farbb[COUNTERFARBE];
	float anzahl,distance,withoutbrakeLook,iswaterpixel;
	float farbdistance[COUNTERFARBE];
	float waterpixeldistance;
        int farbzaehler;
};
/*struct PIXELFARBEEIGENSCHAFTEN
{
	float farbr[10],farbg[10]
}*/
PIXELSET pixel123[WIDTH][HEIGHT];
float oldtime=0;
float sightX=0.707,sightY=0,sightZ=0.707;
float AugX=-100000,AugY=1000,AugZ=-100000,vecx,vecy,vecz;
float X,Y,Z;
int valid;
int lanz=2,lPointanz=1;
float iks[3]={6,8,6},ips[3]={6,7,4},zet[3]={6,7,3}, rad[3]={1,1,1};
float PX=4500,PY=9000,PZ=4500;
int zaehler2=WIDTH*HEIGHT;
int i;
int zaehler=700;
float xzAngle=45,zyAngle=0;
ELEKTR *elektrisch;
float AA,BB,CC,DD,M,N,O;
float lightX[100], lightY[100], lightZ[100];
float lightXPoint[100], lightYPoint[100], lightZPoint[100];
float lightUpBetrag[100];
float timee=0;
long double faktoris=0.8999;
float distanceis(float xx,float yy,float zz,float mm,float nn,float oo);
float stepup=1;

void RefreshN();
void Set1(ELEKTR *elektrisch);
float distancecalc(float x,float y,float z,float m,float n,float o);
//findXYPoint(elektrisch[i].x,elektrisch[i].y,elektrisch[i].z,0,0,0,1,1,1,0,1,AA,BB,CC,DD,lightX,lightY,lightZ,lightUpBetrag,lightXPoint,lightYPoint,lightZPoint);
void findXYPoint(float x,float y,float z,float RRR,float GGG,float BBB,float alignX,float alignY,float alignZ,int wateris,float WithoutBrakeLook,int indexofelektrisch);
void SetTheCharacter1();
void SetTheCharacter3(float movex,float movey,float movez);
int highestcounter=0;

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_LASTSIM, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_LASTSIM));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_LASTSIM));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_LASTSIM);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
int ison=0;
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		for(int p=0;p<HEIGHT;p++)
		{
			for(int i=0;i<WIDTH;i++)
			{
				SetPixelV(hdc,i,p,RGB(pixel123[i][p].r,pixel123[i][p].g,pixel123[i][p].b));
			}
		}
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_CREATE:
		elektrisch=new ELEKTR[zaehler];
		SetTimer(hWnd,1,1000,NULL);
		for(i=0;i<zaehler;i++)
		{
			elektrisch[i].vx=0;
			elektrisch[i].vy=0;
			elektrisch[i].vz=0;
			elektrisch[i].x=0;
			elektrisch[i].y=0;
			elektrisch[i].z=0;
			elektrisch[i].mass=1;
			elektrisch[i].current=1;
		}
		oldtime=0;
		Set1(elektrisch);
		SetTheCharacter1();
		break;
		
	case WM_TIMER:

		
	
		/*set the environment */
		
	
		/* first setting*/
		sightX=0.707;sightY=0;sightZ=0.707;
		float t;
		float abst;
		float vectorx,vectory,vectorz;
		float A,B;
		float nx,ny,nz,normx,normy,normz;
		int done;

	
	    for(int p=0;p<HEIGHT;p++)
		  for(int i=0;i<WIDTH;i++)
        	for(int ko=0;ko<COUNTERFARBE;ko++)
        	{
        		pixel123[i][p].farbr[ko]=0;
        		pixel123[i][p].farbg[ko]=0;
               	pixel123[i][p].farbb[ko]=0;
				pixel123[i][p].iswaterpixel=0;
	            pixel123[i][p].farbdistance[ko]=DISTANCE;
				pixel123[i][p].waterpixeldistance=DISTANCE;
				pixel123[i][p].r=0;
				pixel123[i][p].g=0;
				pixel123[i][p].b=0;
				pixel123[i][p].distance=0;
				pixel123[i][p].farbzaehler=0;
       		}

		timee+=0.01;
		if(oldtime<timee)
		{
		  done=0;
		  //while(done==0)
		  {
			int counterthis=0;
			counterthis++;
			if(counterthis>100)done=1;
			int indexcounter=0;
			float movex=0,movey=0,movez=0;
			SetTheCharacter3(movex,movey,movez);

			RefreshN();
			// checked the lines 
			float ax,ay,az;
			for(int p=0;p<10;p++)
			{
				for(int i=0;i<zaehler;i++)
				{
					ax=0;ay=0;az=0;
					float fx=0,fy=0,fz=0;
					for(int o=0;o<zaehler;o++)
					{
						if(i!=o)
						{
							float vecx=elektrisch[i].x-elektrisch[o].x;
							float vecy=elektrisch[i].y-elektrisch[o].y;
							float vecz=elektrisch[i].z-elektrisch[o].z;
							float betrag=distanceis(vecx,vecy,vecz,0,0,0);
							vecx/=betrag;
							vecy/=betrag;
							vecz/=betrag;
							float forcex=vecx/(4.0*3.14159*faktoris*faktoris)*elektrisch[i].current*elektrisch[o].current/(distanceis(elektrisch[i].x,elektrisch[i].y,elektrisch[i].z,elektrisch[o].x,elektrisch[o].y,elektrisch[o].z)*
				    				distanceis(elektrisch[i].x,elektrisch[i].y,elektrisch[i].z,elektrisch[o].x,elektrisch[o].y,elektrisch[o].z));
							float forcey=vecy/(4.0*3.14159*faktoris*faktoris)*elektrisch[i].current*elektrisch[o].current/(distanceis(elektrisch[i].x,elektrisch[i].y,elektrisch[i].z,elektrisch[o].x,elektrisch[o].y,elektrisch[o].z)*
				    				distanceis(elektrisch[i].x,elektrisch[i].y,elektrisch[i].z,elektrisch[o].x,elektrisch[o].y,elektrisch[o].z));
							float forcez=vecz/(4.0*3.14159*faktoris*faktoris)*elektrisch[i].current*elektrisch[o].current/(distanceis(elektrisch[i].x,elektrisch[i].y,elektrisch[i].z,elektrisch[o].x,elektrisch[o].y,elektrisch[o].z)*
				    				distanceis(elektrisch[i].x,elektrisch[i].y,elektrisch[i].z,elektrisch[o].x,elektrisch[o].y,elektrisch[o].z));
							ax+=forcex/elektrisch[i].mass;
							ay+=forcey/elektrisch[i].mass;
							az+=forcez/elektrisch[i].mass;
							fx+=forcex;
							fy+=forcey;
							fz+=forcez;
						}
					}
					elektrisch[i].vx+=ax;
					elektrisch[i].vy+=ay;
					elektrisch[i].vz+=az;
					elektrisch[i].x+=elektrisch[i].vx;
					elektrisch[i].y+=elektrisch[i].vy;
					elektrisch[i].z+=elektrisch[i].vz;
					float energie=sqrt(fx*fx+fy*fy+fz*fz)/sqrt(ax*ax+ay*ay+az*az)*C*C;
					float constanth=1;
					float frequenz=energie/constanth;
					float lambda=C/frequenz;
					
					elektrisch[i].r=lambda/0.00012*255;
					elektrisch[i].g=lambda/0.00007*255;
					elektrisch[i].b=lambda/0.000035*255;
					float asg=10;

				}
			}
			sightX=cos(xzAngle*3.14159/180.0);
			sightZ=sin(xzAngle*3.14159/180.0);
			sightY=sin(zyAngle*3.14159/180.0);
			float sightBetrag=distancecalc(sightX,sightY,sightZ,0,0,0);
			sightX/=sightBetrag;
			sightY/=sightBetrag;
			sightZ/=sightBetrag;

			abst=100;
			// correct plane
			X=AugX+sightX*abst;
			Y=AugY+sightY*abst;
			Z=AugZ+sightZ*abst;
	
			// go on normal
			lightX[0]=0;
        	lightY[0]=-1;
        	lightZ[0]=0;
        	lightX[1]=0.707;
        	lightY[1]=0;
        	lightZ[1]=0.707;
			lightXPoint[0]=3;
			lightYPoint[0]=3;
			lightZPoint[0]=3;
			lightUpBetrag[0]=1;

			AA=sightX;
        	BB=sightY;
        	CC=sightZ;

        	float abstandzuObjekt;

			srand(2);
        	// do the math of building the objects
			for(int i=0;i<zaehler;i++)
			{
				findXYPoint(elektrisch[i].x,elektrisch[i].y,elektrisch[i].z,255,255,255,1,1,1,0,1,i);
			}		
			oldtime=timee;
			/*for(int p=0;p<HEIGHT;p++)
			{
				for(int i=0;i<WIDTH;i++)
				{
					pixel123[i][p].r=255;
				}
			}*/
		  }
		}
		InvalidateRect(hWnd,NULL,TRUE);
		break;
	case WM_DESTROY:
		KillTimer(hWnd,1);
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

float distancecalc(float x,float y,float z,float m,float n,float o)
{
        return sqrt((x-m)*(x-m)+(y-n)*(y-n)+(z-o)*(z-o));
}
float distanceis(float xx,float yy,float zz,float mm,float nn,float oo)
{
        return sqrt((xx-mm)*(xx-mm)+(yy-nn)*(yy-nn)+(zz-oo)*(zz-oo));
}
void RefreshN()
{
        for(int p=0;p<HEIGHT;p++)
		for(int i=0;i<WIDTH;i++)
		{
			pixel123[i][p].distance=DISTANCE;
			pixel123[i][p].r=0;
			pixel123[i][p].g=0;
			pixel123[i][p].b=0;
			pixel123[i][p].iswaterpixel=0;
			pixel123[i][p].waterpixeldistance=DISTANCE;

                        /*for(int ko=0;ko<COUNTERFARBE;ko++)
                        {
                                pixel[i][p].farbr[ko]=0;
                                pixel[i][p].farbg[ko]=0;
                                pixel[i][p].farbb[ko]=0;

                                pixel[i][p].farbdistance[ko]=DISTANCE;
                        }*/
                        pixel123[i][p].farbzaehler=0;
		}
}
void findXYPoint(float x,float y,float z,float RRR,float GGG,float BBB,float alignX,float alignY,float alignZ,int wateris,float WithoutBrakeLook,int indexofelektrisch)
{
		if(sightX*(x-X)+sightY*(y-Y)+sightZ*(z-Z)>0)
                {

								valid=1;

                                float alignBetrag=sqrt(alignX*alignX+alignY*alignY+alignZ*alignZ);
                                alignX/=-alignBetrag;
                                alignY/=-alignBetrag;
                                alignZ/=-alignBetrag;
                                float nx=-sightZ;float ny=0;float nz=sightX;
                                float normx=-nz*sightY;
                                float normy=nz*sightX-nx*sightZ;
                                float normz=nx*sightY;
                                // calculate the screen coordinates
                                DD=AA*X+BB*Y+CC*Z;
                                //AA*(AugX+vecx*t)+BB*(AugY+vecy*t)+CC*(AugZ+vecz*t)-DD=0;
                                //AA*AugX+AA*vecx*t+BB*AugY+BB*vecy*t+CC*AugZ+CC*vecz*t-DD=0;
                                //DD-AA*AugX-BB*AugY-CC*AugZ=AA*vecx*t+BB*vecy*t+CC*vecz*t
                                //t= (DD-AA*AugX-BB*AugY-CC*AugZ)
                                //   /
                                //   (AA*vecx+BB+vecy+CC*vecz);
                                /*t = (DD-AA*AugX-BB*AugY-CC*AugZ)
                                        /
                                        (AA*(x-AugX)+BB+(y-AugY)+CC*(z-AugZ));*/
                                float M = AugX+(x-AugX)*(DD-AA*AugX-BB*AugY-CC*AugZ)
                                        /
                                        (AA*(x-AugX)+BB+(y-AugY)+CC*(z-AugZ));
                                float N = AugY+(y-AugY)*(DD-AA*AugX-BB*AugY-CC*AugZ)
                                        /
                                        (AA*(x-AugX)+BB+(y-AugY)+CC*(z-AugZ));
                                float O = AugZ+(z-AugZ)*(DD-AA*AugX-BB*AugY-CC*AugZ)
                                        /
                                        (AA*(x-AugX)+BB+(y-AugY)+CC*(z-AugZ));
                                float vectorx = X-M,vectory=Y-N,vectorz=Z-O;
                                float A=(vectorx*nx+vectory*ny+vectorz*nz)*20+WIDTH/2.0;
                                float B=(vectorx*normx+vectory*normy+vectorz*normz)*20+HEIGHT/2.0;
                        
                                float Lighteness=0;
				// Straight sources
                                for(int qwert=0;qwert<lanz;qwert++)
                                {
                                        if(lightX[qwert]*alignX+lightY[qwert]*alignY+lightZ[qwert]*alignZ>0)
                                        {
                                                Lighteness+=lightX[qwert]*alignX+lightY[qwert]*alignY+lightZ[qwert]*alignZ;
                                        }
                                }
				// Point sources
				for(int qwert2=0;qwert2<lPointanz;qwert2++)
                                {
									   // clear the vector

                                       if(lightUpBetrag[qwert2]*100*((alignX*(x-lightXPoint[qwert2])+alignY*(y-lightYPoint[qwert2])+alignZ*(z-lightZPoint[qwert2]))
											/ (distancecalc(alignX,alignY,alignZ,0,0,0)*distancecalc(x-lightXPoint[qwert2],y-lightYPoint[qwert2],z-lightZPoint[qwert2],0,0,0))
										   )/(distancecalc(lightXPoint[qwert2],lightYPoint[qwert2],lightZPoint[qwert2],x,y,z)*distancecalc(lightXPoint[qwert2],lightYPoint[qwert2],lightZPoint[qwert2],x,y,z))>0)

										Lighteness+=lightUpBetrag[qwert2]*100*(
						                (alignX*(x-lightXPoint[qwert2])+alignY*(y-lightYPoint[qwert2])+alignZ*(z-lightZPoint[qwert2]))
					   	                / (distancecalc(alignX,alignY,alignZ,0,0,0)*distancecalc(x-lightXPoint[qwert2],y-lightYPoint[qwert2],z-lightZPoint[qwert2],0,0,0))
					                )/(distancecalc(lightXPoint[qwert2],lightYPoint[qwert2],lightZPoint[qwert2],x,y,z)*distancecalc(lightXPoint[qwert2],lightYPoint[qwert2],lightZPoint[qwert2],x,y,z));

                                }
				if(Lighteness>1)Lighteness=1;
				Lighteness/=2;
                                if(RRR>255)RRR=255;if(GGG>255)GGG=255;if(BBB>255)BBB=255;

				if(int(A)>0&&int(B)>0&&int(A)<WIDTH&&int(B)<HEIGHT&&pixel123[int(A)][int(B)].distance>distancecalc(x,y,z,AugX,AugY,AugZ))
                                {
                                                                                pixel123[int(A)][int(B)].distance=distancecalc(x,y,z,AugX,AugY,AugZ);
										// add the pixel color because this PIXEL is gonna crack
										pixel123[int(A)][int(B)].r=elektrisch[indexofelektrisch].r*Lighteness;
										pixel123[int(A)][int(B)].g=elektrisch[indexofelektrisch].g*Lighteness;
										pixel123[int(A)][int(B)].b=elektrisch[indexofelektrisch].b*Lighteness;
                                }
                                
		}
		else valid=0;



}
void Set1(ELEKTR *elektrisch)
{
	highestcounter=0;
	int counterofset=0;
	for(int i=0;i<9000;i+=1000)
		for(int o=0;o<9000;o+=1000)
			for(int u=0;u<9000;u+=1000)
			{
				if(distanceis(i,o,u,4500,4500,4500)<4500&&counterofset<zaehler)
				{
					float distis=distanceis(i,o,u,4500,4500,4500);
					elektrisch[counterofset].x=i;
					elektrisch[counterofset].y=o;
					elektrisch[counterofset].z=u;
					elektrisch[counterofset].mass=1;
					if(rand()%2==0)
						elektrisch[counterofset].current=1;
					if(rand()%2==1)
						elektrisch[counterofset].current=-1;
					float winkel1=rand()%360,winkel2=rand()%360;
					elektrisch[counterofset].vx=cos(winkel1*3.14159/180)*FAKTORV;
					elektrisch[counterofset].vy=sin(winkel1*3.14159/180)*FAKTORV;
					elektrisch[counterofset].vz=cos(winkel2*3.14159/180)*FAKTORV;
					counterofset++;
					if(highestcounter<counterofset)
							highestcounter=counterofset;
				}
			}
}

void SetTheCharacter1()
{
	int counter1=highestcounter;
	for(int xxxxxx=0;xxxxxx<50;xxxxxx+=stepup)
			{
				for(int yyyyyy=0;yyyyyy<50;yyyyyy+=stepup)
				{
					
					for(int zzzzzz=0;zzzzzz<20;zzzzzz+=stepup)
					{
						if(counter1<zaehler)
						{
							elektrisch[counter1].x=xxxxxx+PX;
							elektrisch[counter1].y=yyyyyy+PY;
							elektrisch[counter1].z=zzzzzz+PZ;
							counter1++;
						}
					}
				}
			}
		
}
void SetTheCharacter3(float movex,float movey,float movez)
{
	int counter2=0;
	for(int xxxxxx=0;xxxxxx<5;xxxxxx+=stepup)
			{
				for(int yyyyyy=0;yyyyyy<5;yyyyyy+=stepup)
				{
					
					for(int zzzzzz=0;zzzzzz<2;zzzzzz+=stepup)
					{

						elektrisch[counter2].x+=movex;
						elektrisch[counter2].y+=movey;
						elektrisch[counter2].z+=movez;
					}
				}
			}		
}
